﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;

namespace ultraDateTimeEditor
{
	public partial class CsiDateTimeEditor : UltraDateTimeEditor
	{
		public event EventHandler<EventArgs> ValueHasChanged;
		private bool _ddOpen = false;
		private DateTime _originalValue;
		protected virtual void OnValueHasChanged()
		{
			EventHandler<EventArgs> handler = ValueHasChanged;
			if (handler != null) handler(this, EventArgs.Empty);
		}

		public CsiDateTimeEditor()
		{
			InitializeComponent();
		}
		protected override void OnValueChanged(EventArgs args)
		{
			base.OnValueChanged(args);
			if (_ddOpen) return;
			OnValueHasChanged();
		}
		protected override void OnBeforeDropDown(CancelEventArgs args)
		{
			base.OnBeforeDropDown(args);
			if (args.Cancel) return;
			_ddOpen = true;
			_originalValue = DateTime;
		}
		protected override void OnAfterCloseUp(EventArgs args)
		{
			base.OnAfterCloseUp(args);
			_ddOpen = false;
			if (DateTime != _originalValue)
				OnValueHasChanged();
		}
	}
}
